GanttChart Sorting

GanttChart for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { GanttChart } from 'smart-webcomponents-react/ganttchart';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <GanttChart ref={componentRef} {...componentProps}></GanttChart>;
}

Use componentRef.current for API methods in this topic.

Sorting

Smart.GanttChart component uses a Table component which allows to sort the tasks/resources based on a column. The sortMode property determines the sorting mode of the element. Tasks/Resources can be sorted by setting the sortMode property to either one (allows to sort by a single column), many (allows to sort by multiple columns) or none ( disabled sorting ). By default sorting is disabled.

Once the sortMode property is configured to allow sorting, the user has two options to apply sorting to the tasks/resources:

  • Click on a Table column header inside the GanttChart.
  • Call the API's sort method by passing an array of strings which correspond to taskColumn/resourceColumns column values or objects that contain the same with an additional sortOrder attribute that allows to preset the sorting order ('asc' - ascending order or 'desc' - descending order). For example:
    const ganttChart = componentRef.current;
    
    componentRef.current.sortMode = 'one';                            
    componentRef.current.sort([
     { value: 'duration', sortOrder: 'asc', type: 'task' }, 
     { value: 'progress', sortOrder: 'asc', type: 'resource' }
    ]);

    As a result the Tasks will be sorted by their duration in ascending order and the Resources will be sorted by progress in ascending order as well.

The timeline is updated as soon as a Table columns is sorted.

Sorting can be cleared at any time via the clearSort method.

componentRef.current.clearSort()
For AI tooling

Developer Quick Reference

Topic: gantt-sorting   Component: GanttChart   Framework: React

Main methods: sort(), clearSort()

Common config keys: (none detected)

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

GanttChart Sorting

GanttChart for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.ganttchart.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-gantt-chart ref="component"></smart-gantt-chart>
</template>

Use component.value for API methods in this topic.

Sorting

Smart.GanttChart component uses a Table component which allows to sort the tasks/resources based on a column. The sortMode property determines the sorting mode of the element. Tasks/Resources can be sorted by setting the sortMode property to either one (allows to sort by a single column), many (allows to sort by multiple columns) or none ( disabled sorting ). By default sorting is disabled.

Once the sortMode property is configured to allow sorting, the user has two options to apply sorting to the tasks/resources:

  • Click on a Table column header inside the GanttChart.
  • Call the API's sort method by passing an array of strings which correspond to taskColumn/resourceColumns column values or objects that contain the same with an additional sortOrder attribute that allows to preset the sorting order ('asc' - ascending order or 'desc' - descending order). For example:
    const ganttChart = component.value;
    
    component.value.sortMode = 'one';                            
    component.value.sort([
     { value: 'duration', sortOrder: 'asc', type: 'task' }, 
     { value: 'progress', sortOrder: 'asc', type: 'resource' }
    ]);

    As a result the Tasks will be sorted by their duration in ascending order and the Resources will be sorted by progress in ascending order as well.

The timeline is updated as soon as a Table columns is sorted.

Sorting can be cleared at any time via the clearSort method.

component.value.clearSort()
For AI tooling

Developer Quick Reference

Topic: gantt-sorting   Component: GanttChart   Framework: Vue

Main methods: sort(), clearSort()

Common config keys: (none detected)

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with

GanttChart Sorting

GanttChart for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { GanttChartComponent, GanttChartModule } from 'smart-webcomponents-angular/ganttchart';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GanttChartModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('ganttChart', { read: GanttChartComponent, static: false }) ganttChart!: GanttChartComponent;
}
<!-- app.component.html -->
<smart-gantt-chart #ganttChart></smart-gantt-chart>

Use this.ganttChart for API methods in this topic.

Sorting

Smart.GanttChart component uses a Table component which allows to sort the tasks/resources based on a column. The sortMode property determines the sorting mode of the element. Tasks/Resources can be sorted by setting the sortMode property to either one (allows to sort by a single column), many (allows to sort by multiple columns) or none ( disabled sorting ). By default sorting is disabled.

Once the sortMode property is configured to allow sorting, the user has two options to apply sorting to the tasks/resources:

  • Click on a Table column header inside the GanttChart.
  • Call the API's sort method by passing an array of strings which correspond to taskColumn/resourceColumns column values or objects that contain the same with an additional sortOrder attribute that allows to preset the sorting order ('asc' - ascending order or 'desc' - descending order). For example:
    const ganttChart = this.ganttChart;
    
    this.ganttChart.sortMode = 'one';                            
    this.ganttChart.sort([
     { value: 'duration', sortOrder: 'asc', type: 'task' }, 
     { value: 'progress', sortOrder: 'asc', type: 'resource' }
    ]);

    As a result the Tasks will be sorted by their duration in ascending order and the Resources will be sorted by progress in ascending order as well.

The timeline is updated as soon as a Table columns is sorted.

Sorting can be cleared at any time via the clearSort method.

this.ganttChart.clearSort()
For AI tooling

Developer Quick Reference

Topic: gantt-sorting   Component: GanttChart   Framework: Angular

Main methods: sort(), clearSort()

Common config keys: (none detected)

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.